Index: include/ndk/kdtypes.h
===================================================================
--- include/ndk/kdtypes.h	(revision 21808)
+++ include/ndk/kdtypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -47,6 +47,7 @@
 //
 // DebugService Control Types
 //
+#define BREAKPOINT_BREAK                    0
 #define BREAKPOINT_PRINT                    1
 #define BREAKPOINT_PROMPT                   2
 #define BREAKPOINT_LOAD_SYMBOLS             3
@@ -55,25 +56,109 @@
 //
 // Debug Control Codes for NtSystemDebugcontrol
 //
-typedef enum _DEBUG_CONTROL_CODE
+typedef enum _SYSDBG_COMMAND
 {
-    DebugGetTraceInformation = 1,
-    DebugSetInternalBreakpoint,
-    DebugSetSpecialCall,
-    DebugClearSpecialCalls,
-    DebugQuerySpecialCalls,
-    DebugDbgBreakPoint,
-    DebugDbgLoadSymbols
-} DEBUG_CONTROL_CODE;
+    SysDbgQueryModuleInformation = 0,
+    SysDbgQueryTraceInformation = 1,
+    SysDbgSetTracepoint = 2,
+    SysDbgSetSpecialCall = 3,
+    SysDbgClearSpecialCalls = 4,
+    SysDbgQuerySpecialCalls = 5,
+    SysDbgBreakPoint = 6,
+    SysDbgQueryVersion = 7,
+    SysDbgReadVirtual = 8,
+    SysDbgWriteVirtual = 9,
+    SysDbgReadPhysical = 10,
+    SysDbgWritePhysical = 11,
+    SysDbgReadControlSpace = 12,
+    SysDbgWriteControlSpace = 13,
+    SysDbgReadIoSpace = 14,
+    SysDbgWriteIoSpace = 15,
+    SysDbgReadMsr = 16,
+    SysDbgWriteMsr = 17,
+    SysDbgReadBusData = 18,
+    SysDbgWriteBusData = 19,
+    SysDbgCheckLowMemory = 20,
+    SysDbgEnableKernelDebugger = 21,
+    SysDbgDisableKernelDebugger = 22,
+    SysDbgGetAutoKdEnable = 23,
+    SysDbgSetAutoKdEnable = 24,
+    SysDbgGetPrintBufferSize = 25,
+    SysDbgSetPrintBufferSize = 26,
+    SysDbgGetKdUmExceptionEnable = 27,
+    SysDbgSetKdUmExceptionEnable = 28,
+    SysDbgGetTriageDump = 29,
+    SysDbgGetKdBlockEnable = 30,
+    SysDbgSetKdBlockEnable = 31,
+    SysDbgRegisterForUmBreakInfo = 32,
+    SysDbgGetUmBreakPid = 33,
+    SysDbgClearUmBreakPid = 34,
+    SysDbgGetUmAttachPid = 35,
+    SysDbgClearUmAttachPid = 36,
+} SYSDBG_COMMAND;
 
 //
-// Kernel Debugger Port Definition
+// System Debugger Types
 //
-typedef struct _KD_PORT_INFORMATION
+typedef struct _SYSDBG_PHYSICAL
 {
-    ULONG ComPort;
-    ULONG BaudRate;
-    ULONG BaseAddress;
-} KD_PORT_INFORMATION, *PKD_PORT_INFORMATION;
+    PHYSICAL_ADDRESS Address;
+    PVOID Buffer;
+    ULONG Request;
+} SYSDBG_PHYSICAL, *PSYSDBG_PHYSICAL;
 
+typedef struct _SYSDBG_VIRTUAL
+{
+    PVOID Address;
+    PVOID Buffer;
+    ULONG Request;
+} SYSDBG_VIRTUAL, *PSYSDBG_VIRTUAL;
+
+typedef struct _SYSDBG_CONTROL_SPACE
+{
+    ULONGLONG Address;
+    PVOID Buffer;
+    ULONG Request;
+    ULONG Processor;
+} SYSDBG_CONTROL_SPACE, *PSYSDBG_CONTROL_SPACE;
+
+typedef struct _SYSDBG_IO_SPACE
+{
+    ULONGLONG Address;
+    PVOID Buffer;
+    ULONG Request;
+    INTERFACE_TYPE InterfaceType;
+    ULONG BusNumber;
+    ULONG AddressSpace;
+} SYSDBG_IO_SPACE, *PSYSDBG_IO_SPACE;
+
+typedef struct _SYSDBG_BUS_DATA
+{
+    ULONG Address;
+    PVOID Buffer;
+    ULONG Request;
+    BUS_DATA_TYPE BusDataType;
+    ULONG BusNumber;
+    ULONG SlotNumber;
+} SYSDBG_BUS_DATA, *PSYSDBG_BUS_DATA;
+
+typedef struct _SYSDBG_MSR
+{
+    ULONG Address;
+    ULONGLONG Data;
+} SYSDBG_MSR, *PSYSDBG_MSR;
+
+typedef struct _SYSDBG_TRIAGE_DUMP
+{
+    ULONG Flags;
+    ULONG BugCheckCode;
+    ULONG_PTR BugCheckParam1;
+    ULONG_PTR BugCheckParam2;
+    ULONG_PTR BugCheckParam3;
+    ULONG_PTR BugCheckParam4;
+    ULONG ProcessHandles;
+    ULONG ThreadHandles;
+    PHANDLE Handles;
+} SYSDBG_TRIAGE_DUMP, *PSYSDBG_TRIAGE_DUMP;
+
 #endif // _KDTYPES_H
Index: include/ndk/obtypes.h
===================================================================
--- include/ndk/obtypes.h	(revision 21808)
+++ include/ndk/obtypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -49,6 +49,11 @@
 }
 
 //
+// Number of custom-defined bits that can be attached to a handle
+//
+#define OBJ_HANDLE_TAGBITS                      0x3
+
+//
 // Directory Object Access Rights
 //
 #define DIRECTORY_QUERY                         0x0001
@@ -132,7 +137,6 @@
 } OB_DUMP_CONTROL, *POB_DUMP_CONTROL;
 
 #ifndef NTOS_MODE_USER
-#ifndef _REACTOS_
 
 //
 // Object Type Callbacks
@@ -209,87 +213,6 @@
 #else
 
 //
-// FIXME: ReactOS ONLY Object Callbacks
-//
-typedef NTSTATUS
-(NTAPI *OB_OPEN_METHOD)(
-    OB_OPEN_REASON Reason,
-    PVOID ObjectBody,
-    PEPROCESS Process,
-    ULONG HandleCount,
-    ACCESS_MASK GrantedAccess
-);
-
-typedef NTSTATUS
-(NTAPI *OB_PARSE_METHOD)(
-    PVOID Object,
-    PVOID *NextObject,
-    PUNICODE_STRING FullPath,
-    PWSTR *Path,
-    ULONG Attributes
-);
-
-typedef VOID
-(NTAPI *OB_DELETE_METHOD)(
-    PVOID DeletedObject
-);
-
-typedef VOID
-(NTAPI *OB_CLOSE_METHOD)(
-    PVOID ClosedObject,
-    ULONG HandleCount
-);
-
-typedef VOID
-(NTAPI *OB_DUMP_METHOD)(
-    VOID
-);
-
-typedef NTSTATUS
-(NTAPI *OB_OKAYTOCLOSE_METHOD)(
-    VOID
-);
-
-typedef NTSTATUS
-(NTAPI *OB_QUERYNAME_METHOD)(
-    PVOID ObjectBody,
-    POBJECT_NAME_INFORMATION ObjectNameInfo,
-    ULONG Length,
-    PULONG ReturnLength
-);
-
-typedef PVOID
-(NTAPI *OB_FIND_METHOD)(
-    PVOID  WinStaObject,
-    PWSTR  Name,
-    ULONG  Attributes
-);
-
-typedef NTSTATUS
-(NTAPI *OB_SECURITY_METHOD)(
-    PVOID Object,
-    SECURITY_OPERATION_CODE OperationType,
-    SECURITY_INFORMATION SecurityInformation,
-    PSECURITY_DESCRIPTOR NewSecurityDescriptor,
-    PULONG ReturnLength,
-    PSECURITY_DESCRIPTOR *OldSecurityDescriptor,
-    POOL_TYPE PoolType,
-    PGENERIC_MAPPING GenericMapping
-);
-
-typedef NTSTATUS
-(NTAPI *OB_CREATE_METHOD)(
-    PVOID ObjectBody,
-    PVOID Parent,
-    PWSTR RemainingPath,
-    struct _OBJECT_ATTRIBUTES* ObjectAttributes
-);
-
-#endif
-
-#else
-
-//
 // Object Information Types for NtQueryInformationObject
 //
 typedef struct _OBJECT_NAME_INFORMATION
@@ -434,9 +357,6 @@
 //
 typedef struct _OBJECT_HEADER
 {
-#ifdef _REACTOS_
-    LIST_ENTRY Entry; // FIXME: REACTOS ONLY
-#endif
     LONG PointerCount;
     union
     {
Index: include/ndk/rtltypes.h
===================================================================
--- include/ndk/rtltypes.h	(revision 21808)
+++ include/ndk/rtltypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -42,6 +42,9 @@
 #define RTL_USER_PROCESS_PARAMETERS_DISABLE_HEAP_CHECKS      0x100
 #define RTL_USER_PROCESS_PARAMETERS_PROCESS_OR_1             0x200
 #define RTL_USER_PROCESS_PARAMETERS_PROCESS_OR_2             0x400
+#define RTL_USER_PROCESS_PARAMETERS_PRIVATE_DLL_PATH         0x1000
+#define RTL_USER_PROCESS_PARAMETERS_LOCAL_DLL_PATH           0x2000
+#define RTL_USER_PROCESS_PARAMETERS_NX                       0x20000
 
 //
 // Exception Flags
@@ -50,6 +53,7 @@
 #define EXCEPTION_UNWINDING                                  0x02
 #define EXCEPTION_EXIT_UNWIND                                0x04
 #define EXCEPTION_STACK_INVALID                              0x08
+#define EXCEPTION_UNWIND                                     (EXCEPTION_UNWINDING + EXCEPTION_EXIT_UNWIND)
 #define EXCEPTION_NESTED_CALL                                0x10
 #define EXCEPTION_TARGET_UNWIND                              0x20
 #define EXCEPTION_COLLIDED_UNWIND                            0x20
@@ -64,6 +68,26 @@
 #define RTL_RANGE_CONFLICT                                   0x02
 
 //
+// Activation Context Frame Flags
+//
+#define RTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_FORMAT_WHISTLER \
+                                                            0x1
+
+//
+// Heap Flags
+//
+#define HEAP_CLASS_0                                        0x00000000
+#define HEAP_CLASS_1                                        0x00001000
+#define HEAP_CLASS_2                                        0x00002000
+#define HEAP_CLASS_3                                        0x00003000
+#define HEAP_CLASS_4                                        0x00004000
+#define HEAP_CLASS_5                                        0x00005000
+#define HEAP_CLASS_6                                        0x00006000
+#define HEAP_CLASS_7                                        0x00007000
+#define HEAP_CLASS_8                                        0x00008000
+#define HEAP_CLASS_MASK                                     0x0000F000
+
+//
 // Registry Keys
 //
 #define RTL_REGISTRY_ABSOLUTE                                0
@@ -120,6 +144,12 @@
 #define RTL_CRITSECT_TYPE                                   0
 #define RTL_RESOURCE_TYPE                                   1
 
+//
+// RtlAcquirePrivileges Flags
+//
+#define RTL_ACQUIRE_PRIVILEGE_IMPERSONATE                   1
+#define RTL_ACQUIRE_PRIVILEGE_PROCESS                       2
+
 #ifdef NTOS_MODE_USER
 
 //
@@ -141,6 +171,12 @@
 #define NLS_MB_CODE_PAGE_TAG                                NlsMbCodePageTag
 #define NLS_MB_OEM_CODE_PAGE_TAG                            NlsMbOemCodePageTag
 #define NLS_OEM_LEAD_BYTE_INFO                              NlsOemLeadByteInfo
+#else
+//
+// Message Resource Flag
+//
+#define MESSAGE_RESOURCE_UNICODE                            0x0001
+
 #endif
 #define MAXIMUM_LEADBYTES                                   12
 
@@ -165,6 +201,14 @@
 #define RTL_ATOM_IS_PINNED                                  0x1
 
 //
+// Critical section lock bits
+//
+#define CS_LOCK_BIT                                         0x1
+#define CS_LOCK_BIT_V                                       0x0
+#define CS_LOCK_WAITER_WOKEN                                0x2
+#define CS_LOCK_WAITER_INC                                  0x4
+
+//
 // Codepage Tags
 //
 #ifdef NTOS_MODE_USER
@@ -221,14 +265,14 @@
 //
 typedef enum _RTL_PATH_TYPE
 {
-    INVALID_PATH = 0,
-    UNC_PATH,              // "//foo"
-    ABSOLUTE_DRIVE_PATH,   // "c:/foo"
-    RELATIVE_DRIVE_PATH,   // "c:foo"
-    ABSOLUTE_PATH,         // "/foo"
-    RELATIVE_PATH,         // "foo"
-    DEVICE_PATH,           // "//./foo"
-    UNC_DOT_PATH           // "//."
+    RtlPathTypeUnknown,
+    RtlPathTypeUncAbsolute,
+    RtlPathTypeDriveAbsolute,
+    RtlPathTypeDriveRelative,
+    RtlPathTypeRooted,
+    RtlPathTypeRelative,
+    RtlPathTypeLocalDevice,
+    RtlPathTypeRootLocalDevice,
 } RTL_PATH_TYPE;
 
 #ifndef NTOS_MODE_USER
@@ -263,6 +307,30 @@
     IN OUT PVOID DispatcherContext
 );
 
+//
+// RTL Library Allocation/Free Routines
+//
+typedef PVOID
+(NTAPI *PRTL_ALLOCATE_STRING_ROUTINE)(
+    SIZE_T NumberOfBytes
+);
+
+typedef PVOID
+(NTAPI *PRTL_REALLOCATE_STRING_ROUTINE)(
+    SIZE_T NumberOfBytes,
+    PVOID Buffer
+);
+
+typedef
+VOID
+(NTAPI *PRTL_FREE_STRING_ROUTINE)(
+    PVOID Buffer
+);
+
+extern const PRTL_ALLOCATE_STRING_ROUTINE RtlAllocateStringRoutine;
+extern const PRTL_FREE_STRING_ROUTINE RtlFreeStringRoutine;
+extern const PRTL_REALLOCATE_STRING_ROUTINE RtlReallocateStringRoutine;
+
 #endif
 
 //
@@ -538,7 +606,39 @@
     CSHORT Weekday;
 } TIME_FIELDS, *PTIME_FIELDS;
 
+//
+// Activation Context
+//
+typedef PVOID PACTIVATION_CONTEXT;
+
+//
+// Activation Context Frame
+//
+typedef struct _RTL_ACTIVATION_CONTEXT_STACK_FRAME
+{
+    struct __RTL_ACTIVATION_CONTEXT_STACK_FRAME *Previous;
+    PACTIVATION_CONTEXT ActivationContext;
+    ULONG Flags;
+} RTL_ACTIVATION_CONTEXT_STACK_FRAME,
+  *PRTL_ACTIVATION_CONTEXT_STACK_FRAME;
+
+typedef struct _RTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_EXTENDED
+{
+    ULONG Size;
+    ULONG Format;
+    RTL_ACTIVATION_CONTEXT_STACK_FRAME Frame;
+    PVOID Extra1;
+    PVOID Extra2;
+    PVOID Extra3;
+    PVOID Extra4;
+} RTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_EXTENDED,
+  *PRTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_EXTENDED;
+
 #endif
+
+//
+// ACE Structure
+//
 typedef struct _ACE
 {
     ACE_HEADER Header;
@@ -550,42 +650,54 @@
 //
 typedef struct _RTL_PROCESS_MODULE_INFORMATION
 {
-    ULONG Reserved[2];
-    PVOID Base;
-    ULONG Size;
+    ULONG Section;
+    PVOID MappedBase;
+    PVOID ImageBase;
+    ULONG ImageSize;
     ULONG Flags;
-    USHORT Index;
-    USHORT Unknown;
+    USHORT LoadOrderIndex;
+    USHORT InitOrderIndex;
     USHORT LoadCount;
-    USHORT ModuleNameOffset;
-    CHAR ImageName[256];
+    USHORT OffsetToFileName;
+    CHAR FullPathName[256];
 } RTL_PROCESS_MODULE_INFORMATION, *PRTL_PROCESS_MODULE_INFORMATION;
 
 typedef struct _RTL_PROCESS_MODULES
 {
-    ULONG ModuleCount;
-    RTL_PROCESS_MODULE_INFORMATION ModuleEntry[1];
+    ULONG NumberOfModules;
+    RTL_PROCESS_MODULE_INFORMATION Modules[1];
 } RTL_PROCESS_MODULES, *PRTL_PROCESS_MODULES;
 
-typedef struct _RTL_PROCESS_HEAP_INFORMATION
+typedef struct _RTL_PROCESS_MODULE_INFORMATION_EX
 {
-    PVOID Base;
+    ULONG NextOffset;
+    RTL_PROCESS_MODULE_INFORMATION BaseInfo;
+    ULONG ImageCheckSum;
+    ULONG TimeDateStamp;
+    PVOID DefaultBase;
+} RTL_PROCESS_MODULE_INFORMATION_EX, *PRTL_PROCESS_MODULE_INFORMATION_EX;
+
+typedef struct _RTL_HEAP_INFORMATION
+{
+    PVOID BaseAddress;
     ULONG Flags;
-    USHORT Granularity;
-    USHORT Unknown;
-    ULONG Allocated;
-    ULONG Committed;
-    ULONG TagCount;
-    ULONG BlockCount;
-    ULONG Reserved[7];
+    USHORT EntryOverhead;
+    USHORT CreatorBackTraceIndex;
+    ULONG BytesAllocated;
+    ULONG BytesCommitted;
+    ULONG NumberOfTags;
+    ULONG NumberOfEntries;
+    ULONG NumberOfPseudoTags;
+    ULONG PseudoTagGranularity;
+    ULONG Reserved[4];
     PVOID Tags;
-    PVOID Blocks;
-} RTL_PROCESS_HEAP_INFORMATION, *PRTL_PROCESS_HEAP_INFORMATION;
+    PVOID Entries;
+} RTL_HEAP_INFORMATION, *PRTL_HEAP_INFORMATION;
 
 typedef struct _RTL_PROCESS_HEAPS
 {
-    ULONG HeapCount;
-    RTL_PROCESS_HEAP_INFORMATION HeapEntry[1];
+    ULONG NumberOfHeaps;
+    RTL_HEAP_INFORMATION Heaps[1];
 } RTL_PROCESS_HEAPS, *PRTL_PROCESS_HEAPS;
 
 typedef struct _RTL_PROCESS_LOCK_INFORMATION
@@ -604,8 +716,8 @@
 
 typedef struct _RTL_PROCESS_LOCKS
 {
-    ULONG LockCount;
-    RTL_PROCESS_LOCK_INFORMATION LockEntry[1];
+    ULONG NumberOfLocks;
+    RTL_PROCESS_LOCK_INFORMATION Locks[1];
 } RTL_PROCESS_LOCKS, *PRTL_PROCESS_LOCKS;
 
 typedef struct _RTL_PROCESS_BACKTRACE_INFORMATION
@@ -626,27 +738,61 @@
     RTL_PROCESS_BACKTRACE_INFORMATION BackTraces[1];
 } RTL_PROCESS_BACKTRACES, *PRTL_PROCESS_BACKTRACES;
 
-typedef struct _RTL_DEBUG_BUFFER
+typedef struct _RTL_PROCESS_VERIFIER_OPTIONS
 {
-    HANDLE SectionHandle;
-    PVOID SectionBase;
-    PVOID RemoteSectionBase;
-    ULONG SectionBaseDelta;
-    HANDLE EventPairHandle;
-    ULONG Unknown[2];
-    HANDLE RemoteThreadHandle;
-    ULONG InfoClassMask;
-    ULONG SizeOfInfo;
-    ULONG AllocatedSize;
-    ULONG SectionSize;
-    PRTL_PROCESS_MODULES ModuleInformation;
-    PRTL_PROCESS_BACKTRACES BackTraceInformation;
-    PRTL_PROCESS_HEAPS HeapInformation;
-    PRTL_PROCESS_LOCKS LockInformation;
-    PVOID Reserved[8];
-} RTL_DEBUG_BUFFER, *PRTL_DEBUG_BUFFER;
+    ULONG SizeStruct;
+    ULONG Option;
+    UCHAR OptionData[1];
+    //
+    // Option array continues below
+    //
+} RTL_PROCESS_VERIFIER_OPTIONS, *PRTL_PROCESS_VERIFIER_OPTIONS;
 
+typedef struct _RTL_DEBUG_INFORMATION
+{
+    HANDLE SectionHandleClient;
+    PVOID ViewBaseClient;
+    PVOID ViewBaseTarget;
+    ULONG ViewBaseDelta;
+    HANDLE EventPairClient;
+    PVOID EventPairTarget;
+    HANDLE TargetProcessId;
+    HANDLE TargetThreadHandle;
+    ULONG Flags;
+    ULONG OffsetFree;
+    ULONG CommitSize;
+    ULONG ViewSize;
+    union
+    {
+        PRTL_PROCESS_MODULES Modules;
+        PRTL_PROCESS_MODULE_INFORMATION_EX ModulesEx;
+    };
+    PRTL_PROCESS_BACKTRACES BackTraces;
+    PRTL_PROCESS_HEAPS Heaps;
+    PRTL_PROCESS_LOCKS Locks;
+    HANDLE SpecificHeap;
+    HANDLE TargetProcessHandle;
+    RTL_PROCESS_VERIFIER_OPTIONS VerifierOptions;
+    HANDLE ProcessHeap;
+    HANDLE CriticalSectionHandle;
+    HANDLE CriticalSectionOwnerThread;
+    PVOID Reserved[4];
+} RTL_DEBUG_INFORMATION, *PRTL_DEBUG_INFORMATION;
+
 //
+// Unload Event Trace Structure for RtlGetUnloadEventTrace
+//
+typedef struct _RTL_UNLOAD_EVENT_TRACE
+{
+    PVOID BaseAddress;
+    ULONG SizeOfImage;
+    ULONG Sequence;
+    ULONG TimeDateStamp;
+    ULONG CheckSum;
+    WCHAR ImageName[32];
+} RTL_UNLOAD_EVENT_TRACE, *PRTL_UNLOAD_EVENT_TRACE;
+
+//
 // RTL Handle Structures
 //
 typedef struct _RTL_HANDLE_TABLE_ENTRY
@@ -692,6 +838,19 @@
     UNICODE_STRING DosPath;
 } RTL_DRIVE_LETTER_CURDIR, *PRTL_DRIVE_LETTER_CURDIR;
 
+//
+// Private State structure for RtlAcquirePrivilege/RtlReleasePrivilege
+//
+typedef struct _RTL_ACQUIRE_STATE
+{
+    HANDLE Token;
+    HANDLE OldImpersonationToken;
+    PTOKEN_PRIVILEGES OldPrivileges;
+    PTOKEN_PRIVILEGES NewPrivileges;
+    ULONG Flags;
+    UCHAR OldPrivBuffer[1024];
+} RTL_ACQUIRE_STATE, *PRTL_ACQUIRE_STATE;
+
 #ifndef NTOS_MODE_USER
 
 //
@@ -718,7 +877,7 @@
     ULONG_PTR SpinCount;
 } RTL_CRITICAL_SECTION, *PRTL_CRITICAL_SECTION;
 
-#else
+#endif
 
 //
 // RTL Range List Structures
@@ -749,8 +908,6 @@
     ULONG Stamp;
 } RTL_RANGE_LIST_ITERATOR, *PRTL_RANGE_LIST_ITERATOR;
 
-#endif
-
 //
 // RTL Resource
 //
@@ -902,6 +1059,24 @@
 #endif
 
 //
+// Hotpatch Header
+//
+typedef struct _RTL_PATCH_HEADER
+{
+    LIST_ENTRY PatchList;
+    PVOID PatchImageBase;
+    struct _RTL_PATCH_HEADER *NextPath;
+    ULONG PatchFlags;
+    LONG PatchRefCount;
+    struct _HOTPATCH_HEADER *HotpatchHeader;
+    UNICODE_STRING TargetDllName;
+    PVOID TargetDllBase;
+    PLDR_DATA_TABLE_ENTRY TargetLdrDataTableEntry;
+    PLDR_DATA_TABLE_ENTRY PatchLdrDataTableEntry;
+    struct _SYSTEM_HOTPATCH_CODE_INFORMATION *CodeInfo;
+} RTL_PATCH_HEADER, *PRTL_PATCH_HEADER;
+
+//
 // Header for NLS Files
 //
 typedef struct _NLS_FILE_HEADER
@@ -917,4 +1092,47 @@
     UCHAR LeadByte[MAXIMUM_LEADBYTES];
 } NLS_FILE_HEADER, *PNLS_FILE_HEADER;
 
+//
+// Stack Traces
+//
+typedef struct _RTL_STACK_TRACE_ENTRY
+{
+    struct _RTL_STACK_TRACE_ENTRY *HashChain;
+    ULONG TraceCount;
+    USHORT Index;
+    USHORT Depth;
+    PVOID BackTrace[32];
+} RTL_STACK_TRACE_ENTRY, *PRTL_STACK_TRACE_ENTRY;
+
+typedef struct _STACK_TRACE_DATABASE
+{
+    RTL_CRITICAL_SECTION CriticalSection;
+} STACK_TRACE_DATABASE, *PSTACK_TRACE_DATABASE;
+
+#ifndef NTOS_MODE_USER
+
+//
+// Message Resource Entry, Block and Data
+//
+typedef struct _MESSAGE_RESOURCE_ENTRY
+{
+    USHORT Length;
+    USHORT Flags;
+    UCHAR Text[ANYSIZE_ARRAY];
+} MESSAGE_RESOURCE_ENTRY, *PMESSAGE_RESOURCE_ENTRY;
+
+typedef struct _MESSAGE_RESOURCE_BLOCK
+{
+    ULONG LowId;
+    ULONG HighId;
+    ULONG OffsetToEntries;
+} MESSAGE_RESOURCE_BLOCK, *PMESSAGE_RESOURCE_BLOCK;
+
+typedef struct _MESSAGE_RESOURCE_DATA
+{
+    ULONG NumberOfBlocks;
+    MESSAGE_RESOURCE_BLOCK Blocks[ANYSIZE_ARRAY];
+} MESSAGE_RESOURCE_DATA, *PMESSAGE_RESOURCE_DATA;
+
 #endif
+#endif
Index: include/ndk/inbvfuncs.h
===================================================================
--- include/ndk/inbvfuncs.h	(revision 21808)
+++ include/ndk/inbvfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -54,7 +54,7 @@
 VOID
 NTAPI
 InbvInstallDisplayStringFilter(
-    IN PVOID Unknown
+    IN PVOID DisplayFilter
 );
 
 BOOLEAN
Index: include/ndk/cmfuncs.h
===================================================================
--- include/ndk/cmfuncs.h	(revision 21808)
+++ include/ndk/cmfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
Index: include/ndk/kefuncs.h
===================================================================
--- include/ndk/kefuncs.h	(revision 21808)
+++ include/ndk/kefuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -111,6 +111,20 @@
     PKSPIN_LOCK SpinLock
 );
 
+KIRQL
+FASTCALL
+KeAcquireQueuedSpinLockRaiseToSynch(
+    IN KSPIN_LOCK_QUEUE_NUMBER LockNumber
+);
+
+KIRQL
+FASTCALL
+KeAcquireInStackQueuedSpinLockRaiseToSynch(
+    IN PKSPIN_LOCK SpinLock,
+    IN PKLOCK_QUEUE_HANDLE LockHandle
+);
+
+
 //
 // Interrupt Functions
 //
@@ -172,9 +186,17 @@
     VOID
 );
 
+BOOLEAN
+NTAPI
+KiIpiServiceRoutine(
+    IN PKTRAP_FRAME TrapFrame,
+    IN PVOID ExceptionFrame
+);
+
 //
-// ARC Configuration Functions
+// ARC Configuration Functions. Only enabled if you have ARC Support
 //
+#ifdef _ARC_
 PCONFIGURATION_COMPONENT_DATA
 NTAPI
 KeFindConfigurationNextEntry(
@@ -193,6 +215,7 @@
     IN CONFIGURATION_TYPE Type,
     IN PULONG ComponentKey OPTIONAL
 );
+#endif
 
 //
 // Low-level Hardware/CPU Control Functions
@@ -200,12 +223,26 @@
 VOID
 NTAPI
 KeFlushEntireTb(
-    IN BOOLEAN Unknown,
-    IN BOOLEAN CurrentCpuOnly
+    IN BOOLEAN Invalid,
+    IN BOOLEAN AllProcessors
 );
 
 VOID
 NTAPI
+KeUpdateSystemTime(
+    PKTRAP_FRAME TrapFrame,
+    KIRQL Irql
+);
+
+VOID
+NTAPI
+KeUpdateRunTime(
+    PKTRAP_FRAME TrapFrame,
+    KIRQL Irql
+);
+
+VOID
+NTAPI
 KeSetDmaIoCoherency(
     IN ULONG Coherency
 );
@@ -230,6 +267,13 @@
     IN ULONG MinIncrement
 );
 
+NTSTATUS
+NTAPI
+Ke386CallBios(
+    IN ULONG BiosCommand,
+    IN OUT PCONTEXT BiosArguments
+);
+
 //
 // Misc. Functions
 //
@@ -449,8 +493,8 @@
     IN ULONG RoutineIndex,
     IN PVOID Argument,
     IN ULONG ArgumentLength,
-    OUT PVOID* Result,
-    OUT PULONG ResultLength
+    OUT PVOID* Result OPTIONAL,
+    OUT PULONG ResultLength OPTIONAL
 );
 
 NTSYSCALLAPI
